#include "12864Serial.h"
#include <intrins.h>
uchar str[4];

#define DelayNop() {_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();}

void delay_ms(uint z)
{
	uint i,j;
	for(i=110;i>0;i--)
		for(j=z;j>0;j--);
}

void  sendbyte(uchar date)  //Ӹλʼһλһλ
{
	uchar i;
	for(i=0;i<8;i++)
	{
		//LCD_SCLK=0;	
		if((date<<i)&0x80)
		{
			LCD_SID=1;	
		}
		else 
		{
			LCD_SID=0;
		} 
		LCD_SCLK=0;
		LCD_SCLK=1;
	}

}

//12864
uchar receivebyte(void)
{
	uchar i,temp1=0,temp2=0;
	for(i=0;i<8;i++)
	{
		temp1=temp1<<1;
		LCD_SCLK=0;
		LCD_SCLK=1;
		LCD_SCLK=0;
		if(LCD_SID)
			temp1++;
	}

	for(i=0;i<8;i++)
	{
		temp2=temp2<<1;
		LCD_SCLK=0;
		LCD_SCLK=1;
		LCD_SCLK=0;
		if(LCD_SID)
			temp2++;	
	}

	return((temp1&0xf0)+(temp2&0x0f));
}

void CheckBusy(void)
{
	do sendbyte(0xfc);
	while(0x80&receivebyte());
}

void LCD_WriteCmd(uchar cmd)
{
	LCD_CS=1;
	CheckBusy();
	sendbyte(0xf8);  //0xf8
	sendbyte(cmd & 0xf0); //ȷָĸλ
	sendbyte((cmd<<4) & 0xf0); //ڷָĵλ	
	delay_ms(2);	
}

void LCD_WriteDat(uchar dat)
{
	LCD_CS=1;
	CheckBusy();
	sendbyte(0xfa);  //0xfa
	sendbyte(dat&0xf0); //ȷݵĸλ
	sendbyte((dat<<4)&0xf0); //ڷݵĵλ	
	delay_ms(2);	
}



void LCD_Init()
{
	LCD_WriteCmd(0x30);
	LCD_WriteCmd(0x0c);
	LCD_WriteCmd(0x01);		
}

//====================================================================//
// ﷨ʽvoid Lcd_SetPos(uchar X,uchar Y)
// ʵֹܣ趨ʾλ
//     X - УY - 
//   ֵ
//====================================================================//
void Lcd_SetPos(uchar X,uchar Y)
{                          
   uchar  pos;
   if (X==0)
     {X=0x80;}
   else if (X==1)
     {X=0x90;}
   else if (X==2)
     {X=0x88;}
   else if (X==3)
     {X=0x98;}
   pos = X+Y ;  
   LCD_WriteCmd(pos);     //ʾַ
}

//====================================================================//
// ﷨ʽuchar *uchartostr(uchar num)
// ʵֹܣһֽڵnumתΪַ
//====================================================================//
uchar *uchartostr(uchar num)
{
	uchar bai,shi,ge,n;
	bai=num/100;
	shi=num%100/10;
	ge=num%10;
	n=0;

	if(bai!=0)
	{
		str[n]=bai+48;	 //ֵ48Ϊַ
		n++;
	}

	if(!(bai==0&shi==0))
	{
		str[n]=shi+48;
		n++;
	}

	str[n]=ge+48;
	n++;
	str[n]='\0';

	return str;
}

//====================================================================//
// ﷨ʽvoid Lcd_DispLine(uchar line, uchar pos, uchar *str)
// ʵֹܣʾһַ
//     line - ָУpos - ָλãУ str - ַ
//   ֵ
//====================================================================//
void Lcd_DispLine(uchar line, uchar pos, uchar *str)
{
	int i = 0;
	Lcd_SetPos(line, pos);
	while (str[i] != '\0')
	{
		LCD_WriteDat(str[i]);
		i++;
	}
}				 











